﻿param($installPath, $toolsPath, $package, $project)
function FindRegisterRouteFunction($project)
{
	$asax = $project.ProjectItems | where {$_.Name -eq 'Global.asax'}
	$asax = $asax.ProjectItems | where {$_.Name -eq 'Global.asax.cs'}
	
	$namespace = $asax.FileCodeModel.CodeElements | where {$_.Kind -eq 5}

	$methods = $namespace.Children | % {$_.Children}
	$registerRoutesFunction = $methods | where {$_.Name -eq "RegisterRoutes"};
	
	$registerRoutesFunction.FullName;
}

function ReplaceFileContents($project, $filename, $toReplace, $replaceWith) {
	[io.file]::AppendAllText("c:\_package\qq.txt", "aa")
	[io.file]::AppendAllText("c:\_package\qq.txt", $filename)
	$projectDir = [io.path]::GetDirectoryName($project.FullName)
	[io.file]::AppendAllText("c:\_package\qq.txt", "bb")
	$filePath = [io.path]::Combine($projectDir, "Scripts\T4MvcJs\" + $filename)
	$contents = [io.file]::ReadAllText($filePath)
	[io.file]::AppendAllText("c:\_package\qq.txt", $contents)
	[io.file]::AppendAllText("c:\_package\qq.txt", $toReplace)
	[io.file]::AppendAllText("c:\_package\qq.txt", $replaceWith)
	$contents = $contents.Replace($toReplace, $replaceWith)

	[io.file]::WriteAllText($filePath, $contents)
}

$registerRouteFunction = FindRegisterRouteFunction($project)
[io.file]::AppendAllText("c:\_package\qq.txt", "aa")
ReplaceFileContents $project "T4Proxy.cs" "//#MvcApplication.RegisterRoutes#" $registerRouteFunction

ReplaceFileContents $project "T4MvcJs.tt" "`$(ProjectDir)`$(OutDir)T4MvcJs.RoutesHandler.dll" ("`$(SolutionDir)packages\" + $package.Replace(" ", ".") + "\lib\T4MvcJs.RoutesHandler.dll")